#include "Cora.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <float.h>

#include <math.h>

float float_min (float * inArr, int size, int *index)
{
  int   i;
  float min;

  if (inArr != NULL)
    min = inArr[0];
  else 
    return 0.;

  for (i = 0; i < size; ++i)
   if (min > inArr[i])
     {
        min = inArr[i];
        *index = i;
     }
/*    min = (min < inArr[i]) ? min : inArr[i];  */

  return min;
}

float float_max (float * inArr, int size, int *index)
{
  int   i;
  float max;

  if (inArr != NULL)
    max = inArr[0];
  else 
    return 99999.;

  for (i = 0; i < size; ++i)
   if (max < inArr[i])
     {
        max = inArr[i];
        *index = i;
     }
/*    max = (max > inArr[i]) ? max : inArr[i];  */
  return max;
}

double double_max (double * inArr, int size)
{
  int   i;
  double max;

  if (inArr != NULL)
    max = inArr[0];
  else 
    return 99999.;

  for (i = 0; i < size; ++i)
    max = (max > inArr[i]) ? max : inArr[i];

  return max;
}

double double_min (double * inArr, int size)
{
  int   i;
  double min;

  if (inArr != NULL)
    min = inArr[0];
  else 
    return 0.;

  for (i = 0; i < size; ++i)
    min = (min < inArr[i]) ? min : inArr[i];

  return min;
}

/*  ------------------------ */

float clamp_float (float minimum, float x, float maximum, char *pname)
{
  if (x > maximum || x < minimum)
    {
      if (maximum < FLT_MAX)
        g_warning("%s:  %f: out of range [%f...%f]", 
	      pname, x, minimum, maximum);
      else
	g_warning("%s:  %f: out of range [%f... Inf]",
	      pname, x, minimum);
      if (x > maximum)
	{
	  g_warning(" using %f instead",maximum);
	  return (maximum);
	}
      else
	{
	  g_warning(" using %f instead",minimum);
	  return (minimum);
	}
    }
  return (x);
}
  
/*  ------------------------ */

int clamp_int (int minimum, int x, int maximum, char *pname)
{
  if (x > maximum || x < minimum)
    {
      g_warning("%s:  %d: out of range [%d...%d]", 
	      pname, x, minimum, maximum);
      if (x > maximum)
        {
          g_warning(" using %d instead",maximum);
          return (maximum);
        }
      else
        {
          g_warning(" using %d instead",minimum);
          return (minimum);
        }
    }
  return (x);
}

/*  ------------------------ */

int read_input (char *path, int s_flag)
{

  /* read the configuration file 'path'.                            */
  /* s_flag == 0: startup, file may be missing                      */
  /* s_flag == 1: user has selected a file, thus it must be present */
  char version[5];
  char entry_text[3 * MAXTEXTL];
  FILE *fd;
  int i, iloop, num = 0, j, index;
  int totlines=0;
  float infloat, f2, f3, f4, f5, f6, f7, f8;
  double dummy;
  float * test;
 
  fd = fopen (path, "r");
  if (!fd)
    {
      i = errno;
      if (s_flag == 1)
        {
          g_warning("fopen: %s: %s", path,strerror (i));
          return (-1);
        }
      else
	if (verbose > 1)
	  g_message("fopen: %s: %s, using defaults", 
		    path, strerror (i));
      return(1);
    }
  
  totlines=0;
  while (NULL != fgets (entry_text, 128, fd))
    {
      if (entry_text[0] == '#')
        continue;
      if (entry_text[0] == ' ')
        continue;
      if (entry_text[0] == ';')
        continue;
      if (entry_text[0] == '\n')
        continue;
      if (entry_text[0] == '\t')
        continue;
      ++totlines;      
    }

  fclose(fd);

  for (iloop = 0; iloop < nlines; ++iloop)
    {
      pro_type[iloop] = P_GAUSS;  /* line type        */
      fit_wave[iloop] = TRUE;     /* fit wavelength ? */
      fit_sigm[iloop] = TRUE;     /* fit sigma ?      */
      fit_lock[iloop] = FALSE;    /* lock to previous */
      beta[iloop] = 1.;           /* beta profile */
    }


  fd = fopen (path, "r");

  j = 0;
  if (verbose > 2)
    g_message("listing input parameters...");

  while (NULL != fgets (entry_text, 128, fd))
    {
      if (verbose > 2)
	g_message("%s", entry_text);
      
      ++j;
      if (entry_text[0] == '#')
        continue;
      if (entry_text[0] == ' ')
        continue;
      if (entry_text[0] == ';')
        continue;
      if (entry_text[0] == '\n')
        continue;
      if (entry_text[0] == '\t')
        continue;
      i = 0;
      while (entry_text[i] != '\0')
        {
          if (entry_text[i] == ',')
            entry_text[i] = ' ';
          ++i;
        }

      i = sscanf (entry_text, 
		  "%f %f %f %f %f %f %f %f", 
		  &infloat, &f2, &f3, &f4, &f5, &f6, &f7, &f8);

      if (i < 1 && num > 1)
        {
	  g_warning("Format error: %s, line %d: %s.", 
		    path, j - 1, entry_text);
	  return(-1);
        }
      
      if (num == 0)
	{
	  g_snprintf (version, 5, "%s", entry_text);

	  if (verbose) 
	    g_message("Version %s", version);
	  
	  if(atof((char *) version) != atof((char *) VERSION))
	    {
	      g_warning("Wrong version of parameter file (%3f != %3f)",
			atof((char *) version), atof((char *) VERSION));
	      printf("               setting missing parameters with defaults\n");
/*	      fclose(fd);
	      return(2);  */
	    }
	}

      if (num == 1)
	{
#ifdef HAVE_SNPRINTF
	  if (0 == strncmp(entry_text,"NULL",4))
	   snprintf (fittitle, MAXTEXTL, "%s","");
	  else
	   snprintf (fittitle, MAXTEXTL, "%s", entry_text);
#else
	  if (0 == strncmp(entry_text,"NULL",4))
	   sprintf(fittitle, "%s","");
	  else
	   sprintf(fittitle, "%s", entry_text);
#endif
	  if (verbose > 1) 
	    g_message("Title: %s", fittitle);
	}

      if (num == 2)
	{
	  nlines = clamp_int(1, floor (infloat), MAXLINES, "nlines");
	  
	  if (verbose > 1) 
	    g_message("Lines %d", nlines);
          if(totlines < 12+nlines)
	    {
	      g_warning("Invalid parameter file %s", path);
	      g_warning(" ->  %d lines expected", 12+nlines);
	      return(-1);
	    }
	}
      
      /* read in the lines
       */
      if (num > 2 && num < nlines + 3)
        {

          lambda[num - 3] = 
	    clamp_float(float_min(wave,count,&index),
			infloat,
			float_max(wave,count,&index), "lambda");

          sigma[num - 3]         = f2;

	  if (i > 2)
	    f[num -3]            = f3;
	  else
	    f[num -3]            = 0.0;

	  if (i > 3)
	    pro_type[num -3]     = f4;
	  else
	    pro_type[num -3]     = P_GAUSS;

	  if (i > 4)
	    fit_wave[num -3]     = f5;
	  else
	    fit_wave[num -3]     = TRUE;

	  if (i > 5)
	    fit_sigm[num -3]     = f6;
	  else
	    fit_sigm[num -3]     = TRUE;

	  if (i > 6)
	    fit_lock[num -3]     = f7;
	  else
	    fit_lock[num -3]     = FALSE;

	  if (i > 7)
	    beta[num -3]	 = f8;

          if(sigma[num-3] < 0.)
            {
	      g_warning("sigma:  %f: out of range [%f...]", sigma[num-3], 0.0);
	      sigma[num-3]=fabs(sigma[num-3]);
	      g_warning(" -> using %f instead", sigma[num-3]);
            }

	  if (verbose > 1) 
	    g_message("Line %d(%d):  Lambda %7.4f Sigma %7.4f Weight %5.2f "\
		      "P %d F(l) %d F(s) %d L %d bet %f\n", 
		      num - 3, i, lambda[num - 3], sigma[num - 3],
		      f[num -3], pro_type[num -3], fit_wave[num -3],
		      fit_sigm[num -3], fit_lock[num -3],beta[num-3]);
        }


      if (num == nlines + 3)
        {
	  if(double_max(sigma,nlines)<=0.)
	    {
	      g_warning("\n** Error **: All sigma values are negative!\n"\
			"*            At least one value must be positive.\n"\
			"*            Negative values will be replaced by\n"\
			"*            the largest positive value.");
	      return(-1);
	    }
          app_s = infloat;
          app_b = f2;
	  if (app_s <= 0.)
	    {
	      fprintf(stderr,"*  Warning  *: Non-positive apertures make no sense! Setting to 1\n");
	      app_s=1.;
	    }
	  if (app_b <= 0.)
	    {
	      fprintf(stderr,"*  Warning  *: Non-positive apertures make no sense! Setting to 1\n");
	      app_b=1.;
	    }
	  if (i > 2)
	    v     = f3;
	  else
	    v     = 0.0;
	  if (i > 3)
            fixflag = clamp_int(0,floor (f4),1,"fixflag");
          else
            fixflag = 1;
        }

      if (num == nlines + 4)
        {
          sbg = clamp_float(0.,infloat,FLT_MAX,"sbg");
	  if(sbg<0.)
	    {
	      g_warning("%s:  %f: out of range [%f...]","sbg",sbg,0.0);
	      g_warning(" using %f instead",0.0);
	      sbg=0.0;
	    }
          sbgit    = clamp_int(0,floor (f2),1,"sbgit");
          bgsmooth = clamp_int(0,floor (f3),1,"bgsmooth");
	  sbgchi   = clamp_int(0,floor (f4),1,"sbgchi");
	  medsig   = clamp_float(0.1, f5, FLT_MAX,"medsig");
        }

      if (num == nlines + 5)
        {
          test = (float *) malloc (sizeof(float) * nlines);
	  if (test == NULL)
	    {
	      g_warning("Out of memory !");
	      return (-1);
	    }
	  j=0;
	  for(iloop=0; iloop<nlines; ++iloop) 
	    {
	      if (sigma[iloop] > 0.) 
		{
		  test[j] = sigma[iloop];
		  ++j;
		}
	    }

          dsig    = 
	    clamp_float(0., fabs (infloat), 4.0 * float_min(test, j, &index),
			"dsig");
	  free(test);
          sigunit = clamp_int(0,floor (f2),1,"sigunit");
          dlam    = 
	    clamp_float(0., fabs (f3), 
			double_min(lambda,nlines)-float_min(wave,count,&index),
			"dlam");
	  ikev	  = clamp_int(0,floor(f4),1,"ikev");
        }

      if (num == nlines + 6)
	{
	  ilamit = clamp_int(0,floor (infloat),1,"ilamit");
	  idlam  = clamp_int(0,floor (f2),1,"idlam");
	  if (f3 == 0.) 
	    f3=1.;
	  iord   = 
	    clamp_float(.1,f3,
			float_max(wave,count,&index)/double_max(lambda,nlines),
			"iord");
	  idsig  = clamp_int(0,floor (f4),1,"idsig");
 	}

      if (num == nlines + 7)
        isigit = clamp_int(0,floor (infloat),1,"isigit");

      if (num == nlines + 8)
	if (ires!=1) 
	  ires = clamp_int(0,floor (infloat),1,"ires");

      if (num == nlines + 9)
	{
	  iformat   = clamp_int(0,floor (infloat),3,"iformat");
	  iportrait = clamp_int(0,floor (f2),1,"iportait");
	}

      if (num == nlines + 10)
        {
          iplot     = clamp_int(0,floor (infloat),1,"iplot");
          ilab      = clamp_int(0,floor (f2),1,"ilab");
          ierrplot  = clamp_int(0,floor (f3),1,"ierrplot");
          ilog      = clamp_int(0,floor (f4),1,"ilog");
          nbin      = clamp_int(1,floor (f5),20,"nbin");
	  if (i > 5)
	   {
	    spec_only = clamp_int(0,floor (f6),1,"spec_only");
	    fit_only = clamp_int(0,floor (f7),1,"fit_only");
	   }
	  else
	    {spec_only = 0;fit_only = 0;}
        }

      if (num == nlines + 11)
        {
          nlik = clamp_int(0,floor (infloat),1000,"nlik");
          ispline = clamp_int(0,floor (f2),1,"ispline");
        }
      ++num;
    }
  if (verbose > 2)
    g_message("... listing of input parameters completed");
  
  fclose(fd);
  
  /*************************************/
  /*     more consistency checks       */
  /*************************************/
  
  /*   adjust non useful sigma values  */
  dummy=double_max(sigma,nlines);
  for (i=0; i<nlines; ++i) 
    if (sigma[i]<=0.) 
      sigma[i]=dummy;

  for(num = 0; num < nlines; ++num)
    {

      pro_type[num] =
	clamp_int  (P_MIN,      pro_type[num],     P_MAX,      "profile type");
      fit_wave[num] =
	clamp_int  (FALSE,      fit_wave[num],     TRUE,       "fit lambda");
      fit_sigm[num] =
	clamp_int  (FALSE,      fit_sigm[num],     TRUE,       "fit sigma");
      fit_lock[num] =
	clamp_int  (FALSE,      fit_lock[num],     TRUE,       "lock lambda");

    }

  /*   set locked wavelengths          */
  if (fit_lock[0] == TRUE)
    fit_lock[0] = FALSE;

  for (i=1; i < nlines; ++i) 
    if (fit_lock[i] == TRUE)
      lambda[i] = lambda[i-1];


  /* ***************************************************************
   *
   * we purposely do NOT set the other flags (fit_wave, fit_sigma) 
   * according to ilamit, isigit - this way the user can switch easier
   * between global/individual option
   *
   * ***************************************************************/ 
  
  
  return(0);
}
